package etudiantAppli;

import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class EtudiantForm extends JPanel {
	private JTextField nomField = new JTextField();

	private JTextField prenomField = new JTextField();

	private JTextField ageField = new JTextField();

	private JButton okButton = new JButton();

	/**
	 * Default constructor
	 */
	public EtudiantForm() {
		initializePanel();
	}

	
	
	/**
	 * Adds fill components to empty cells in the first row and first column of
	 * the grid. This ensures that the grid spacing will be the same as shown in
	 * the designer.
	 * 
	 * @param cols
	 *            an array of column indices in the first row where fill
	 *            components should be added.
	 * @param rows
	 *            an array of row indices in the first column where fill
	 *            components should be added.
	 */
	void addFillComponents(Container panel, int[] cols, int[] rows) {
		Dimension filler = new Dimension(10, 10);

		boolean filled_cell_11 = false;
		CellConstraints cc = new CellConstraints();
		if (cols.length > 0 && rows.length > 0) {
			if (cols[0] == 1 && rows[0] == 1) {
				/** add a rigid area */
				panel.add(Box.createRigidArea(filler), cc.xy(1, 1));
				filled_cell_11 = true;
			}
		}

		for (int index = 0; index < cols.length; index++) {
			if (cols[index] == 1 && filled_cell_11) {
				continue;
			}
			panel.add(Box.createRigidArea(filler), cc.xy(cols[index], 1));
		}

		for (int index = 0; index < rows.length; index++) {
			if (rows[index] == 1 && filled_cell_11) {
				continue;
			}
			panel.add(Box.createRigidArea(filler), cc.xy(1, rows[index]));
		}

	}

	public JPanel createPanel() {
		JPanel jpanel1 = new JPanel();
		FormLayout formlayout1 = new FormLayout(
				"FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE",
				"CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE,CENTER:DEFAULT:NONE,CENTER:4DLU:NONE");
		CellConstraints cc = new CellConstraints();
		jpanel1.setLayout(formlayout1);

		JLabel jlabel1 = new JLabel();
		jlabel1.setText("Etudiant");
		jlabel1.setHorizontalAlignment(JLabel.CENTER);
		jpanel1.add(jlabel1, cc.xywh(2, 2, 3, 1));

		JLabel jlabel2 = new JLabel();
		jlabel2.setText("Prenom");
		jpanel1.add(jlabel2, cc.xy(2, 6));

		JLabel jlabel3 = new JLabel();
		jlabel3.setText("Nom");
		jpanel1.add(jlabel3, cc.xy(2, 4));

		JLabel jlabel4 = new JLabel();
		jlabel4.setText("Age");
		jpanel1.add(jlabel4, cc.xy(2, 8));

		nomField.setColumns(20);
		nomField.setName("nom");
		jpanel1.add(nomField, cc.xy(4, 4));

		prenomField.setName("prenom");
		jpanel1.add(prenomField, cc.xy(4, 6));

		ageField.setName("age");
		jpanel1.add(ageField, cc.xy(4, 8));

		jpanel1.add(createPanel1(), new CellConstraints(2, 10, 3, 1,
				CellConstraints.FILL, CellConstraints.FILL));
		addFillComponents(jpanel1, new int[] { 1, 2, 3, 4, 5 }, new int[] { 1,
				2, 3, 4, 5, 6, 7, 8, 9, 10, 11 });
		return jpanel1;
	}

	public JPanel createPanel1() {
		JPanel jpanel1 = new JPanel();
		FormLayout formlayout1 = new FormLayout(
				"FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0)",
				"CENTER:DEFAULT:NONE");
		CellConstraints cc = new CellConstraints();
		jpanel1.setLayout(formlayout1);

		okButton.setActionCommand("Enregistrer");
		okButton.setText("Enregistrer");
		jpanel1.add(okButton, new CellConstraints(4, 1, 1, 1,
				CellConstraints.RIGHT, CellConstraints.DEFAULT));

		addFillComponents(jpanel1, new int[] { 1, 2, 3 }, new int[] { 1 });
		return jpanel1;
	}

	/**
	 * Initializer
	 */
	protected void initializePanel() {
		setLayout(new BorderLayout());
		add(createPanel(), BorderLayout.CENTER);
	}

	/**
	 * @return Returns the ageField.
	 */
	public JTextField getAgeField() {
		return ageField;
	}

	/**
	 * @param ageField
	 *            The ageField to set.
	 */
	public void setM_age(JTextField m_age) {
		this.ageField = m_age;
	}

	/**
	 * @return Returns the nomField.
	 */
	public JTextField getNomField() {
		return nomField;
	}

	/**
	 * @param nomField
	 *            The nomField to set.
	 */
	public void setM_nom(JTextField m_nom) {
		this.nomField = m_nom;
	}

	/**
	 * @return Returns the okButton.
	 */
	public JButton getOkButton() {
		return okButton;
	}

	/**
	 * @param button
	 *            The okButton to set.
	 */
	public void setM_okButton(JButton button) {
		okButton = button;
	}

	/**
	 * @return Returns the prenomField.
	 */
	public JTextField getPrenomField() {
		return prenomField;
	}

	/**
	 * @param prenomField
	 *            The prenomField to set.
	 */
	public void setM_prenom(JTextField m_prenom) {
		this.prenomField = m_prenom;
	}

}
